package cz.upol.jj1.seminar5;

import java.math.BigDecimal;
import java.util.Arrays;
import java.util.List;

public class Main {

    public static void main(String[] args) {
        //krabicka pro integery
	    BoxInt bi = new BoxInt(1);

        //obecnejsi krabicka (double zvladne i int, ale chovani je trochu jine...)
        BoxDouble bd1 = new BoxDouble(1);
        BoxDouble bd2 = new BoxDouble(1.0);

        //jeste obecnjeis krabicka (Number je predek vsech cisel)
        BoxNumber bn1 = new BoxNumber(1);
        BoxNumber bn2 = new BoxNumber(1.0);
        BoxNumber bn3 = new BoxNumber(new BigDecimal(1));

        //obsah krabicky jako double
        System.out.println(bn2.getValue().doubleValue());

        //krabicka pro pole je uz ale uplne jina...
        BoxArray ba = new BoxArray(new int[]{1,1,1});

        //krabicka pro object to zdanlive resi, ...
        BoxObject bo1 = new BoxObject(1);
        BoxObject bo2 = new BoxObject(1.0);
        BoxObject bo3 = new BoxObject(new BigDecimal(1));
        BoxObject bo4 = new BoxObject(new int[]{1,1,1});


        //... ale ...
        int bo1Val = (int)bo1.getValue();
        double bo2Val = (double)bo2.getValue();
        BigDecimal bo3Val = (BigDecimal)bo3.getValue();
        int[] bo4Val = (int[])bo4.getValue();
        //... toto je dost nachylne k chybam
        // programator si musi pamatovat, kam co dal
        // realne se vzdavame typove kontroly


        //mimo to si vsimnete, ze vsechny krabicky maji skoro stejny kod
        // - lisi se jen v typech


        // generika - jedna genericka trida
        // nam diky pridani typoveho parametru
        // umozni "generovat" vsechny tridy vyse na pozadani


        //nezminil jsem, vysvetlim priste...
        //--->
        //int vs Integer
        //hodnotovy vs objektovy typ
        //autoboxing, unboxing
        //<---


        //diamond notation pri vytvareni instance
        GenericBox<Integer> gbi1 = new GenericBox<>(1);

        GenericBox<Double> gbd1 = new GenericBox<>(Double.valueOf(1));
        GenericBox<Double> gbd2 = new GenericBox<>(1.0);

        GenericBox<Number> gbn1 = new GenericBox<>(1);
        GenericBox<Number> gbn2 = new GenericBox<>(1.0);
        GenericBox<Number> gbn3 = new GenericBox<>(new BigDecimal(1));

        GenericBox<int[]> gba1 = new GenericBox<>(new int[]{1,1,1});

        GenericBox<Object> gbo1 = new GenericBox<>(1);
        GenericBox<Object> gbo2 = new GenericBox<>(1.0);
        GenericBox<Object> gbo3 = new GenericBox<>(new BigDecimal(1));
        GenericBox<Object> gbo4 = new GenericBox<>(new int[]{1,1,1});

        //tedy misto peti ruznych krabic, nam staci jeden predpis pro krabice
        //a kdyz nekdo bude chtit krabici, tak si rekne pro jaky typ

        //typicky se pouziva pro kolekce - vizte dale
        //ale lze pouzit i jinde

        //vice typovych parametru a jejich omezeni
        // - trida ComparablePair<U,V>
        ComparablePair<ExtendedItemA, ExtendedItemB> pair =
                new ComparablePair<>(
                        new ExtendedItemA(100, 15),
                        new ExtendedItemB(150, 2));
        System.out.println(pair.min());
    }



    //JINE POUZITI GENERIKY

    //metody s generickymi parametry
    public static double sumOfList1(List<Number> list) {
        double s = 0.0;
        for (Number n : list)
            s += n.doubleValue();
        return s;
    }

    //vs

    public static double sumOfList2(List<? extends Number> list) {
        double s = 0.0;
        for (Number n : list)
            s += n.doubleValue();
        return s;
    }


    //rozdil?

    public void callThem(){
        List<Number> n = Arrays.asList(new Number[]{1,2,3});
        List<Double> d = Arrays.asList(new Double[]{1.0,2.0,3.0});
        sumOfList1(n);
        //sumOfList1(d); //nejde d není typu List<Number>
        sumOfList2(n);
        sumOfList2(d);  // jde d je typu List<? extends Number>
    }

    //tedy <? extends Number> je horni mez - musi to byt odvozeno od NUmber
    //podobne mame <? super Number> - dolni mez - Number musi byt odvozeno od pouziteho typu

    //existuji jeste genericke metody, ale to je ted trochu moc - zajemci kouknete do dokumentace


}
